/******************************************************************************
*******************************************************************************
****	Copyright (c) 1997, 1998, 1999, 2000, 2001
****	Conexant Systems Inc. (formerly Rockwell Semiconductor Systems)
****	Personal Computing Division
****	All Rights Reserved
****
****	CONFIDENTIAL and PROPRIETARY --
****		No Dissemination or use without prior written permission.
****
*******************************************************************************
*******************************************************************************
** KEYWORDS:
**	$Archive: /Projects/Tigris and Derivatives Linux/Reference Designs/Tigris/Linux_2.4.3_ATM_Driver/KernelModule/dpcontrollerV1.c $
**	$Revision: 11 $
**	$Date: 7/25/01 5:06p $
******************************************************************************/
#include "linuxmodver.h"

#include "Common.h"
#include "CardALTigrisV.h"
#include "../CommonData.h"
#include "CardALTigrisHal.h"
#include "CardALTigrisHalV.h"
#include "CardALTigrisDp.h"
#include "dpcontrollerV1.h"
#include "ChipALCdslV.h"
#include "CardALV.h"
#include "CardMgmt.h"
#include "sysinfo.h"

/* These variables need sorting out, they are global and COMMON! */
int errno=0;
unsigned long _ungetc[8]={0,0,0,0,0,0,0,0};
enum ANNEX_A_MESS_TONE_SET ANNEX_A_MESS_TONE_SET=0;
int TAO_MODE_OPTION=0;

#if defined(MODVERSIONS)
/*
   This nasty code is to enable references in dpcontroller.o.proprietary to
   printk,sprintf and vsprintf to be resolved indirectly to the kernel routines
   when the CnxADSL.o driver is built with versioned symbols to match a
   versioned symbol kernel.
*/
#define strize(s) #s
#define xx(_x) strize(_x)

void jump_X_table(void) {
#ifdef printk
  __asm__ __volatile__(".global printk\n" "printk:\tjmp " xx(printk)::);
#endif

#ifdef sprintf
  __asm__ __volatile__(".global sprintf\n" "sprintf:\tjmp " xx(sprintf)::);
#endif

#ifdef vsprintf
  __asm__ __volatile__(".global vsprintf\n" "vsprintf:\tjmp " xx(vsprintf)::);
#endif
}
#endif

#if V1
// Tempory Global since Pairgain does not pass handles to the wrapper routines,
// they must load handles from this global for now.

LOCAL PDATAPUMP_CONTEXT pDatapumpCLN;

void InitDatapumpStructureV1
(
 IN PDATAPUMP_CONTEXT pDatapump,
 IN void * pExternalContext
)
{
  // Set global variable that we use since Pairgain code does not pass this to
  // us at this time
  pDatapumpCLN = pDatapump;

  InitDatapumpStructure(pDatapump, pExternalContext);
}

TICK_TYPE ChipAlTigrisDpGetCurrentTick
(
 IN PDATAPUMP_CONTEXT	pDatapump
)
{
  return ChipAlTigrisDpGetCurrentTickV2(pDatapump->pExternalContext);
}

void ChipAlTigrisDpWaitQedfer
(
 IN WORD Flags,
 IN WORD Resolution,
 IN WORD Timeout
)
{
  ChipAlTigrisDpWaitQedferV2(pDatapumpCLN->pExternalContext,
			     Flags, Resolution, Timeout);
}

void ChipAlTigrisDpSignalQedfer
(
 IN WORD Flags
)
{
  ChipAlTigrisDpSignalQedferV2(pDatapumpCLN->pExternalContext,
			       Flags);
}

MODULAR VOID ChipAlTigrisDpDisableIRQ1_2
(
 void
)
{
  ChipAlTigrisDpDisableIRQ1_2V2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpEnableIRQ1_2
(
 void
)
{
  ChipAlTigrisDpEnableIRQ1_2V2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpAtomicStart 
(
 void
)
{
  ChipAlTigrisDpAtomicStartV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpAtomicEnd
(
 void
)
{
  ChipAlTigrisDpAtomicEndV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpSITrap
(
 void
)
{
  ChipAlTigrisDpSITrapV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpIsrStart
(
 void
)
{
  ChipAlTigrisDpIsrStartV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpIsrEnd
(
 void
)
{
  ChipAlTigrisDpIsrEndV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpSetRstXcvr
(
 IN BOOLEAN			State
)
{
  ChipAlTigrisDpSetRstXcvrV2(pDatapumpCLN->pExternalContext,
			     State);
}

MODULAR VOID ChipAlTigrisDpSetGpio
(
 IN BYTE			Pin,
 IN BOOLEAN			State
)
{
  ChipAlTigrisDpSetGpioV2(pDatapumpCLN->pExternalContext,
			  Pin, State);
}

MODULAR VOID ChipAlTigrisDpSetAFEHybridSelect
(
 IN UINT8			Select_Line,
 IN BOOLEAN			State
)
{
  ChipAlTigrisDpSetAFEHybridSelectV2(pDatapumpCLN->pExternalContext,
				     Select_Line, State);
}

MODULAR VOID ChipAlTigrisDpSetPwrDwnXcvr
(
 IN BOOLEAN			State
)
{
  ChipAlTigrisDpSetPwrDwnXcvrV2(pDatapumpCLN->pExternalContext,
				State);
}

MODULAR VOID ChipAlTigrisDpWriteAFE
(
 IN BYTE			Address,
 IN BYTE			Data
)
{
  ChipAlTigrisDpWriteAFEV2(pDatapumpCLN->pExternalContext,
			   Address, Data);
}

MODULAR VOID ChipAlTigrisDpPendingReadAFE
(
 IN BYTE			Address
)
{
  ChipAlTigrisDpPendingReadAFEV2(pDatapumpCLN->pExternalContext,
				 Address);
}

MODULAR BYTE ChipAlTigrisDpReadAFE
(
 void
)
{
  return ChipAlTigrisDpReadAFEV2(pDatapumpCLN->pExternalContext);
}

MODULAR BOOLEAN ChipAlTigrisDpIsAFEDone
(
 void
)
{
  return ChipAlTigrisDpIsAFEDoneV2(pDatapumpCLN->pExternalContext);
}

GLOBAL BOOLEAN ChipAlDpSwitchHookStateEnq
(
 void
)
{
  return ChipAlTigrisDpSwitchHookStateEnqV2(pDatapumpCLN->pExternalContext);
}

MODULAR VOID ChipAlTigrisDpTraceWrite
(
 IN BYTE  Offset,
 IN DWORD Value
)
{
  ChipAlTigrisDpTraceWriteV2(pDatapumpCLN->pExternalContext,
			     Offset, Value);
}

GLOBAL UINT16 ChipAlTigrisDpGetVendorId
(
 void
)
{
  return ChipAlTigrisDpGetVendorIdV2(pDatapumpCLN->pExternalContext);
}

#if 0 /* Not used in linux */
GLOBAL UINT16 ChipAlTigrisDpGetAutoWiring
(
 void
)
{
  return ChipAlTigrisDpGetAutoWiringV2(pDatapumpCLN->pExternalContext);
}

GLOBAL UINT16 ChipAlTigrisDpGetAutoHandshake
(
 void
)
{
  return ChipAlTigrisDpGetAutoHandshakeV2(pDatapumpCLN->pExternalContext);
}

GLOBAL UINT16 ChipAlTigrisDpGetAutoSenseWiresFirst
(
 void
)
{
  return ChipAlTigrisDpGetAutoSenseWiresFirstV2(pDatapumpCLN->pExternalContext);
}
#endif

GLOBAL void ChipAlTigrisDpSetWiring
(
 BOOLEAN			AutomaticDetection,
 SYS_WIRING_SELECTION_TYPE	WiringSelection
)
{
  ChipAlTigrisDpSetWiringV2(pDatapumpCLN->pExternalContext,
			    AutomaticDetection, WiringSelection);
}
#endif
