/******************************************************************************
*******************************************************************************
****	Copyright (c) 1997, 1998, 1999, 2000, 2001
****	Conexant Systems Inc. (formerly Rockwell Semiconductor Systems)
****	Personal Computing Division
****	All Rights Reserved
****
****	CONFIDENTIAL and PROPRIETARY --
****		No Dissemination or use without prior written permission.
****
*******************************************************************************
**
**MODULE NAME:
**	CardAL
**
**FILE NAME:
**	dpcontrollerV1.h
**
**ABSTRACT:
**	CardALTigris Data Pump interface Header File
**
**DETAILS:
**
*******************************************************************************
** KEYWORDS:
**	$Archive: /Projects/Tigris and Derivatives Linux/Reference Designs/Yukon-AV/Linux_2.4_ATM_Driver/KernelModule/dpcontrollerV1.h $
**	$Revision: 8 $
**	$Date: 7/05/01 9:47p $
*******************************************************************************
******************************************************************************/

#ifndef _dpcontrollerV1_H	// File Wrapper
#define	_dpcontrollerV1_H

#include "types.h"
#include "CardMgmt.h"
#include "CardALTigrisHalV.h"
#include "CardALTigrisV.h"
#include "xcvrinfo.h"
#include "sysinfo.h"

#define V1 1

#if V1
void InitDatapumpStructureV1
(
 IN PDATAPUMP_CONTEXT pDatapump,
 IN void * pExternalContext
);

TICK_TYPE ChipAlTigrisDpGetCurrentTick
(
 IN PDATAPUMP_CONTEXT		pDatapump
);

void ChipAlTigrisDpWaitQedfer
(
 IN WORD			Flags,
 IN WORD			Resolution,
 IN WORD			Timeout
);

void ChipAlTigrisDPIndicateLinkUp
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

void ChipAlTigrisDPIndicateLinkDown
(
 IN TIGRIS_CONTEXT_S		* pControllerContextS
);

MODULAR VOID ChipAlTigrisDpAtomicStart
(
 void
);

MODULAR VOID ChipAlTigrisDpAtomicEnd
(
 void
);

MODULAR VOID ChipAlTigrisDpSITrap
(
 void
);

MODULAR VOID ChipAlTigrisDpIsrStart
(
 void
);

MODULAR VOID ChipAlTigrisDpIsrEnd
(
 void
);

MODULAR VOID ChipAlTigrisDpGetNonVolatileParms
(
 IN PDATAPUMP_CONTEXT		pDatapump,
 IN XCVR_OTHER_CFG_TYPE		* pXcvr
);

MODULAR VOID ChipAlTigrisDpDisableIRQ1_2
(
 void
);

MODULAR VOID ChipAlTigrisDpEnableIRQ1_2
(
 void
);

MODULAR VOID ChipAlTigrisDpSetRstXcvr
(
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetGpio
(
 IN BYTE			Pin,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetAFEHybridSelect
(
 IN UINT8			Select_Line,
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpSetPwrDwnXcvr
(
 IN BOOLEAN			State
);

MODULAR VOID ChipAlTigrisDpWriteAFE
(
 IN BYTE			Address,
 IN BYTE			Data
);

MODULAR VOID ChipAlTigrisDpPendingReadAFE
(
 IN BYTE			Address
);

MODULAR BYTE ChipAlTigrisDpReadAFE
(
 void
);

MODULAR BOOLEAN ChipAlTigrisDpIsAFEDone
(
 void
);

GLOBAL BOOLEAN ChipAlDpSwitchHookStateEnq
(
 void
);

MODULAR VOID ChipAlTigrisDpTraceWrite
(
 IN BYTE			Offset,
 IN DWORD			Value
);

GLOBAL UINT16 ChipAlTigrisDpGetVendorId
(
 void
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoWiring
(
 void
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoHandshake
(
 void
);

GLOBAL UINT16 ChipAlTigrisDpGetAutoSenseWiresFirst
(
 void
);

void ChipAlTigrisDpSignalQedfer
(
 IN WORD			Flags
);

GLOBAL void ChipAlTigrisDpSetWiring
(
 BOOLEAN			Automatic,
 SYS_WIRING_SELECTION_TYPE	WiringSelection
);
#endif /* V1 */
#endif	// File Wrapper
